import java.util.*;

public class Third {

    static ArrayDeque<Node> leaves = new ArrayDeque<>();
    static HashMap<Integer, Node> nodes;

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int count = s.nextInt();
        int power = s.nextInt();
        nodes = new HashMap<>(count);
        addNode(0, 1);
        for (int i = 2; i < count + 1; i++) {
            int parent = s.nextInt();
            addNode(parent, i);
        }
        System.out.println(nodes.get(1).maxDepth);
    }

    private static void addNode(int parent, int name) {
        Node parentNode = nodes.get(parent);
        Node child = new Node();
        if (parentNode != null) {
            leaves.remove(parentNode);
            child.parent = parentNode;
            child.parents = parentNode.parents + 1;
            parentNode.updateDepth(1, child);
        }
        leaves.add(child);
        nodes.put(name, child);
    }

    private static class Node {
        int maxDepth = 0;
        Node maxNode;
        Node parent;
        int parents = 0;

        void updateDepth(int depth, Node child) {
            if (maxDepth < depth) {
                maxNode = child;
                maxDepth = depth;
            }
            if (parent != null) {
                parent.updateDepth(depth + 1, this);
            }
        }
    }

}
