import java.util.*;

public class Third {

    static ArrayDeque<Node> leaves = new ArrayDeque<>();
    static HashMap<Integer, Node> nodes;

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int count = s.nextInt();
        int power = s.nextInt();
        nodes = new HashMap<>(count);
        addNode(0, 1);
        for (int i = 2; i < count + 1; i++) {
            int parent = s.nextInt();
            addNode(parent, i);
        }
        int max = -1;
        for (Node node : leaves) {
            int tmp = checkNode(node);
            if (tmp > max) {
                max = tmp;
            }
        }
        System.out.println(max == -1 ? nodes.get(1).maxDepth : max);
    }

    private static int checkNode(Node node) {
        Node parent = node.parent;
        if (parent != null) {
            Node targetParent = parent;
            Node previous = node;
            int depth = 2;
            while (targetParent.parent != null && parent.maxNode == previous) {
                previous = targetParent;
                targetParent = targetParent.parent;
                depth++;
            }
            if (targetParent.maxNode == previous) return -1;
            return Math.max(checkNode(targetParent), depth) + targetParent.maxDepth;
        }
        return -1;
    }

    private static void addNode(int parent, int name) {
        Node parentNode = nodes.get(parent);
        Node child = new Node();
        if (parentNode != null) {
            leaves.remove(parentNode);
            child.parent = parentNode;
            child.parents = parentNode.parents + 1;
            parentNode.updateDepth(1, child);
        }
        leaves.add(child);
        nodes.put(name, child);
    }

    private static class Node {
        int maxDepth = 0;
        Node maxNode;
        Node parent;
        int parents = 0;

        void updateDepth(int depth, Node child) {
            if (maxDepth < depth) {
                maxNode = child;
                maxDepth = depth;
            }
            if (parent != null) {
                parent.updateDepth(depth + 1, this);
            }
        }
    }

}
